using fichier1.Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using fichier1.Controllers;

namespace fichier1
{
    static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        public static ServiceProvider ServiceProvider { get; private set; }

        [STAThread]
        static void Main()
        {
            var path = Path.GetDirectoryName(AppDomain.CurrentDomain.BaseDirectory);
            // setup l'injection de dpendance
            var serviceCollection = new ServiceCollection();
            serviceCollection.AddDbContext<BddContext>(options =>
                options.UseSqlite($"Data Source={path}\\Bdd.db"));

            Application.SetHighDpiMode(HighDpiMode.SystemAware);
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            //serviceCollection.AddSingleton<Form1>();
            serviceCollection.AddScoped<IGameController, GameController>();
            ServiceProvider = serviceCollection.BuildServiceProvider();
            ServiceProvider.GetRequiredService<BddContext>().Database.EnsureCreated();

            //var form1 = ServiceProvider.GetRequiredService<Form1>();

            //Application.Run(form1);
        }
    }
}
